"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (models, plugins, defaultOptions) => {
    const result = {};
    plugins.forEach((plugin) => {
        for (const model of models) {
            let options = ((model.sgSchema.options || {}).plugin || {})[plugin.name];
            if (options === undefined) {
                options = defaultOptions[plugin.name];
            }
            if (options === undefined) {
                options = plugin.defaultOptions;
            }
            if (options != null && options.enable === true && plugin.applyToModel) {
                plugin.applyToModel(model, options, models);
            }
        }
    });
    models.forEach((model) => {
        result[model.name] = model;
    });
    return result;
};
//# sourceMappingURL=applyPluginsToModels.js.map