"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const graphql = __importStar(require("graphql"));
const lodash_1 = __importDefault(require("lodash"));
const relay = __importStar(require("graphql-relay"));
const toGraphQLFieldConfigMap_1 = __importDefault(require("../transformer/toGraphQLFieldConfigMap"));
const toGraphQLInputFieldConfigMap_1 = __importDefault(require("../transformer/toGraphQLInputFieldConfigMap"));
const StringHelper_1 = __importDefault(require("../utils/StringHelper"));
exports.default = (queryConfigMaps, context, nodeQueryConfig) => {
    const queries = {};
    const addQuery = (name, options) => {
        if (queries[name]) {
            throw new Error(`Query ${name} already defined.`);
        }
        const fieldConfig = (0, toGraphQLFieldConfigMap_1.default)(name, 'Payload', { '': options.output }, context)[''];
        const finalOptions = Object.assign({}, options);
        const fieldResolve = fieldConfig.resolve;
        if (fieldResolve) {
            const resolve = finalOptions.resolve;
            finalOptions.resolve = function (args, context, info, sgContext) {
                return __awaiter(this, void 0, void 0, function* () {
                    return fieldResolve({
                        [info.fieldName]: yield resolve(args, context, info, sgContext)
                    }, args, context, info);
                });
            };
        }
        queries[name] = {
            type: fieldConfig.type,
            resolve: context.hookQueryResolve(name, finalOptions),
            description: options.description
        };
        if (options.input || fieldConfig.args) {
            queries[name].args = Object.assign(Object.assign({}, fieldConfig.args), (0, toGraphQLInputFieldConfigMap_1.default)(StringHelper_1.default.toInitialUpperCase(name), Object.assign({}, options.input), context));
        }
    };
    for (let queryConfigMap of queryConfigMaps) {
        lodash_1.default.forOwn(queryConfigMap, (value, key) => {
            addQuery(key, value);
        });
    }
    queries.viewer = {
        description: 'Default Viewer implement to include all queries.',
        type: new graphql.GraphQLNonNull(new graphql.GraphQLObjectType({
            name: 'Viewer',
            fields: Object.assign({ id: { type: new graphql.GraphQLNonNull(graphql.GraphQLID) } }, queries)
        })),
        resolve: () => {
            return {
                _fieldType: 'Viewer',
                id: relay.toGlobalId('Viewer', 'viewer')
            };
        }
    };
    queries.node = {
        description: 'Fetches an object given its ID',
        type: context.interface('Node'),
        args: {
            id: {
                type: new graphql.GraphQLNonNull(graphql.GraphQLID),
                description: 'The ID of an object'
            }
        },
        resolve: context.hookQueryResolve('node', {
            hookOptions: nodeQueryConfig === null || nodeQueryConfig === void 0 ? void 0 : nodeQueryConfig.hookOptions,
            output: {
                properties: {
                    id: { type: 'Id' }
                }
            },
            resolve: function (args, context, info, sgContext) {
                return __awaiter(this, void 0, void 0, function* () {
                    const id = relay.fromGlobalId(args.id);
                    if (!sgContext.models[id.type])
                        return null;
                    const dbModel = sgContext.models[id.type];
                    const record = yield dbModel.findByPkForGraphQL(id.id, {}, context, info);
                    return record;
                });
            }
        })
    };
    return queries;
};
//# sourceMappingURL=buildRootQueries.js.map