"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const sequelize_1 = __importDefault(require("sequelize"));
const dataloader_1 = __importDefault(require("dataloader"));
const getFindOptionsKey_1 = __importDefault(require("../../plugin/cache/getFindOptionsKey"));
function default_1(id, options, context, info, path) {
    return __awaiter(this, void 0, void 0, function* () {
        const dbModel = this;
        if (context == null)
            context = {};
        if (!context.dataloaderMap)
            context.dataloaderMap = {};
        const option = dbModel.resolveQueryOption({
            attributes: options.attributes,
            include: options.include,
            info: info,
            path: path
        });
        const key = `${dbModel.name}.findByPk|${(0, getFindOptionsKey_1.default)(dbModel, option)}`;
        if (!context.dataloaderMap[key]) {
            context.dataloaderMap[key] = new dataloader_1.default(function (ids) {
                return __awaiter(this, void 0, void 0, function* () {
                    const condition = {
                        where: {
                            id: { [sequelize_1.default.Op.in]: ids }
                        },
                        include: option.include,
                        attributes: option.attributes
                    };
                    const mapResult = (records) => ids.map((id) => records.find((r) => r.id + '' === id + ''));
                    if (dbModel.withCache) {
                        return mapResult(yield dbModel.withCache().findAll(condition));
                    }
                    else {
                        return mapResult(yield dbModel.findAll(condition));
                    }
                });
            });
        }
        return context.dataloaderMap[key].load(id);
    });
}
exports.default = default_1;
//# sourceMappingURL=findByPkForGraphQL.js.map