"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const StringHelper_1 = __importDefault(require("../utils/StringHelper"));
exports.default = {
    name: 'deleteMutation',
    defaultOptions: {
        enable: false
    },
    priority: 0,
    description: 'Gen `delete mutation` for Schema',
    applyToSchema: function (schema, options, schemas) {
        const name = 'delete' + StringHelper_1.default.toInitialUpperCase(schema.name);
        const { enable } = options, config = __rest(options, ["enable"]);
        schema.mutations({
            [config.name || name]: {
                hookOptions: config.hookOptions,
                input: {
                    id: {
                        type: schema.name + 'Id',
                        nullable: false
                    }
                },
                output: {
                    ['deleted' + schema.name]: { type: schema.name }
                },
                mutateAndGetPayload: function ({ id }, context, info, sgContext) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const entity = yield sgContext.models[schema.name].findOne({
                            where: { id: id }
                        });
                        if (entity) {
                            yield entity.destroy();
                            return {
                                ['deleted' + schema.name]: entity
                            };
                        }
                        throw new Error(schema.name + '[' + id + '] not exist.');
                    });
                }
            }
        });
    }
};
//# sourceMappingURL=deleteMutationPlugin.js.map