"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = __importStar(require("lodash"));
const StringHelper_1 = __importDefault(require("../utils/StringHelper"));
exports.default = {
    name: 'singularQuery',
    defaultOptions: {
        enable: false
    },
    priority: 0,
    description: 'Gen `singular query` for Schema',
    applyToSchema: function singularQuery(schema, options, schemas) {
        const name = StringHelper_1.default.toInitialLowerCase(schema.name);
        const isModelType = (fieldOptions) => fieldOptions.type && schemas[fieldOptions.type] != null;
        //TODO support mapper setting
        const searchFields = {
            id: {
                type: schema.name + 'Id',
                metadata: {
                    description: 'Id of Schema ' + schema.name
                }
            }
        };
        _.forOwn(schema.config.fields, (value, key) => {
            var _a, _b, _c, _d, _e;
            if (((_b = (_a = value.metadata) === null || _a === void 0 ? void 0 : _a.graphql) === null || _b === void 0 ? void 0 : _b.hidden) !== true &&
                ((_d = (_c = value.metadata) === null || _c === void 0 ? void 0 : _c.column) === null || _d === void 0 ? void 0 : _d.unique) !== true) {
                if (isModelType(value)) {
                    if (!key.endsWith('Id')) {
                        key = key + 'Id';
                    }
                }
                searchFields[key] = Object.assign(Object.assign({}, value), { nullable: true, metadata: { description: (_e = value.metadata) === null || _e === void 0 ? void 0 : _e.description } });
            }
        });
        const { enable } = options, config = __rest(options, ["enable"]);
        schema.queries({
            [config.name || name]: {
                hookOptions: config.hookOptions,
                output: { type: schema.name },
                input: searchFields,
                resolve: function (args, context, info, sgContext) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (args === null || Object.keys(args).length === 0) {
                            return null;
                        }
                        return sgContext.models[schema.name].findOneForGraphQL({
                            where: Object.assign({}, args)
                        }, context, info);
                    });
                }
            }
        });
    }
};
//# sourceMappingURL=singularQueryPlugin.js.map